Hot File

Samples for DOTNETARX (a tool for AutoCAD .NET programming)

View: 940    Dowload: 2   Comment: 0   Post by: naruto  
Author: none   Category: Autodesk AutoCAD   Fields: Computers - Technology

0 point/2 review File has been tested

Download   samples-for-dotnetarx-a-tool.zip (260.01 KB)

You need to Sign In to download the file samples-for-dotnetarx-a-tool.zip
If you do not have an account then Sign up for free here

Download error   Report copyright violation

In this article, I will give you some samples to show you how to use DOTNETARX. DOTNETARX is a tool for developing ObjectARX programs with .NET languages more easily and it provides some functions to fix the bugs in the ObjectARX managed wrapper class. You can learn more about DOTNETARX from the article: Using DOTNETARX To Develop Your .NET ObjectARX Applications. To run the example given in this article, you will have to create a new project and add the DOTNETARX 2.0 assembly, then in your source file add "using DOTNETARX;" to import the DOTNETARX namespace. For a detailed description of the functions given in this article, you can read the help document for DOTNETARX.

Introduction

Conditional filtering

As you know, there is a bug in the managed ObjectARX wrapper class, you can not do conditional filtering with it. For example, you cannot select both circles and lines using the SelectionSet. But with DOTNETARX, you can do it! The following sample code adds circles with a radius of 1.0 and lines on the layer "ABC" to a SelectionSet.

void test() 
{
    TypedValue[] values = new TypedValue[]{
                        new TypedValue(-4,"

AddEntities

In DOTNETARX 1.0, calling Tools.AddEntity() multiple times in a row will be slower than doing everything in a single transaction (J. Daniel Smith on Autodesk discussion group mentioned this). So, I have added the AddEntities() function in 2.0 to solve this problem.

The following sample adds a line and a circle to the current AutoCAD drawing using AddEntities():

void AddLineCircle()
{
    Point3d pt1=new Point3d(0,0,0);
    Point3d pt2=new Point3d(50,50,0);
    Lines line=new Lines(pt1,pt2);
    Point3d center=new Point3d(50,0,0);
    Circles circle=new Circles(center,50);
    Tools.AddEntities(new Entity[]{line,center});
}

Group

The following sample shows you how to add a group into AutoCAD database:

void MakeGroup()
{
    PromptSelectionResult res=
         Tools.Editor.GetSelection();//Selects objects 
    SelectionSet ss=res.Value; //Gets a selection set 
    
    //Gets an array of object IDs
    //representing the selected objects
    ObjectId[] ids=ss.GetObjectIds();  
                                      
    //Creates a Group object named grouptest.
    Group gp=new Group("grouptest",true);
    // Appends the objects whose objectIds are in 
    //the ids array to the group.
    gp.Append(new ObjectIdCollection(ids));
                                           
    Tools.AddDictionaryObject("ASDK_GROUPTEST",gp,
                  Tools.Database.GroupDictionaryId);
    //Use the AddDictionaryObject() function to add the 
    //group object to AutoCAD database.
}

XRecord

The following sample shows you how to add an Xrecord into AutoCAD database:

void MakeXRecord()
{
    Xrecord rec=new Xrecord();//Creates a Xrecord object
    rec.Data=new ResultBuffer(
            new TypedValue((int)DxfCode.Text,
                                "This is a test"),
            new TypedValue((int)DxfCode.Int8,0),
            new TypedValue((int)DxfCode.UcsOrg,
                              new Point3d(0,0,0))
    );//Use the Data property of Xreord to 
      //set the contents of the Xrecord object.
    Tools.AddDictionaryObject("test",rec,
         Tools.Database.NamedObjectsDictionaryId);
    //Use the AddDictionaryObject() function to add the 
    //Xrcord object to AutoCAD database.
    
    //list the entries we just added
    foreach (TypedValue rb in rec.Data) 
    {
       Tools.Editor.WriteMessage(string.Format("TypedCode={0},
                          Value={1}
",rb.TypeCode,rb.Value));
    }
}

XData

The following sample shows you how to add an XData into AutoCAD database:

void MakeXData()
{
    Lines line=new Lines(new Point3d(0,0,0),
                     new Point3d(100,100,0));
    //Creates a line using the Lines 
    //class in DOTNETARX
    RegAppTableRecord app=new RegAppTableRecord();
    //add some xdata on the line, first 
    //have to register an app
    app.Name="MyApp";
    Tools.AddSymbolTableRecord(app,
         Tools.Database.RegAppTableId);
    //Use the AddSymbolTableRecord function 
    //to add the app to the RegAppTable.

    line.XData = new ResultBuffer(new 
       TypedValue((int)DxfCode.ExtendedDataRegAppName,
                                             "MyApp"),
       new TypedValue((int)DxfCode.ExtendedDataAsciiString,
                              "This is some xdata string"));
    //Set the XData property of the line
    Tools.AddEntity(line);//Adds the line 
                          //to database

    // list the entries we just added
    foreach (TypedValue rb in line.XData)
    {
       Tools.Editor.WriteMessage(string.Format("TypedCode={0},
                          Value={1}
",rb.TypeCode,rb.Value));
    }
}

 

The following code uses Copy() to get a copy of the selected entity, and then uses Move() to move the copy to the upper right of the original object:


void test() 
{
    PromptEntityResult res = 
              Tools.Editor.GetEntity("please " + 
                   "select an entity to copy:
");
    ObjectId id= Tools.Copy(res.ObjectId);
    Tools.Move(id,res.PickedPoint,
        res.PickedPoint.Add(new Vector3d(20,20,0)));
}

Mirror

The following example selects an entity and then mirrors it:


void test() 
{
    Editor ed=Tools.Editor;
    PromptEntityResult res =
        ed.GetEntity("please select an entity:
");
    Point3d pt1=ed.GetPoint("Select the " + 
        "first point of the mirror axis:
").Value;
    Point3d pt2=ed.GetPoint("Select the second " + 
               "point of the mirror axis:
").Value;
    Tools.Mirror(res.ObjectId,pt1,pt2,false);
}

Offset

If you use the GetOffsetCurves() function of the managed ObjectARX wrapper class to offset a polyline with a negative number, you will find that AutoCAD makes a "bigger" one. But for other curves such as circles and ellipses, you will get "smaller" ones. I have fixed this bug in DOTNETARX 2.0.

The following example selects an entity and then offsets it:


void test() 
{
    Editor ed=Tools.Editor;
    PromptEntityResult res =
        ed.GetEntity("please select an entity:
");
    Tools.Offset(res.ObjectId,20);
}

Rotate

The following example selects an entity and then rotates it by 45 degrees:


void test() 
{
   Editor ed=Tools.Editor;
   PromptEntityResult res = 
      ed.GetEntity("please select an entity:
");
   Point3d pt1=ed.GetPoint("Select " + 
      "the base point of rotation:
").Value;
   //Note: the angle is in degree
   Tools.Rotate(res.ObjectId,pt1,45);
}

Scale

The following example selects an entity and then scales it:


void test() 
{
   Editor ed=Tools.Editor;
   PromptEntityResult res =
      ed.GetEntity("please select an entity:
");
   Point3d pt1=ed.GetPoint("Select " + 
      "the base point of scaling:
").Value;
   Tools.Scale(res.ObjectId,pt1,2);
}

AddSymbolTableRecord

It is inconvenient to add symbol table records such as layer, text style, line type. With DOTNETARX, you can add them more easily.

The following example creates a layer named Test:


void CreateLayer() 
{
   LayerTableRecord ltr=new LayerTableRecord();
   ltr.Name="Test";
   Tools.AddSymbolTableRecord(ltr,Tools.Database.LayerTableId);
}

GetIteratorForSymbolTable

The following sample uses GetIteratorForSymbolTable() to get an iterator to step through the layer table and print the name of the layers:


void test() 
{
   DBObjectCollection objs = 
      Tools.GetIteratorForSymbolTable(
                    Tools.Database.LayerTableId);
   foreach (DBObject obj in objs)
   {
      LayerTableRecord ltr=(LayerTableRecord)obj;
      Tools.Editor.WriteMessage(ltr.Name+"
");
   }
}

SelectAtPoint

The following sample selects all the objects passing through the point selected by the user:


void test()
{
   PromptPointResult res=Tools.Editor.GetPoint("Please select a point:
");
   Point3d pt=res.Value;
   int n=Tools.SelectAtPoint(pt).Count;
   Tools.Editor.WriteMessage(n.ToString());
}

The following functions are provided in DOTNETARX 2.1.

AddBlockTableRecord

In DOTNETARX, you can add the symbol table record using the AddSymbolTableRecord() function. But the BlockTableRecord is different from the other symbol table records. So, you must use the AddBlockTableRecord() function to add the BlockTableRecord. AddBlockTableRecord() function has two forms. The first one takes the Entity array as its argument (which represents the entities that have not been added into the AutoCAD database). If you want to add the entities on the screen into the BlockTableRecord, you will have to use the second one. It takes the ObjectID of the entities as its argument.

The following example shows you how to use AddBlockTableRecord() to create BlockTableRecords:


void Test()
{
   Lines line = new Lines(new Point3d(0,0,0),
                       new Point3d(50,50,0));
   Circles circle=
       new Circles(new Point3d(50,50,0),25);
   //Creates a new block table record named block1
   BlockTableRecord btr1=new BlockTableRecord();
   btr1.Name="block1";
   btr1.Origin=circle.Center;
   Tools.AddBlockTableRecord(btr1,
          new Entity[]{line,circle});
   //Adds the line and circle to block1,
   //then adds block1 to the block table 
   //of AutoCAD database.

   //Selects objects on the screen.
   PromptSelectionResult res=
         Tools.Editor.GetSelection();
   ObjectIdCollection ids = new 
       ObjectIdCollection(res.Value.GetObjectIds());
   //Gets the ObjectIds of the Selected objects.
   
   //Creates a new block table record named block2
   BlockTableRecord btr2=new BlockTableRecord();
   btr2.Name="block2";
   btr2.Origin=new Point3d(0,0,0);
   Tools.AddBlockTableRecord(btr2,ids);
   //Adds the selected objects to block2,
   //then adds block2 to the block table o
   //f AutoCAD database.
}

CoordFromPixelToWorld() and CoordFromWorldToPixel()

There's no first class .NET API to convert pixel to world coordinates and vise-versa. Special thanks to Albert Szilvasy on Autodesk discussion group for providing a way to solve this problem. The following example shows you how to use CoordFromPixelToWorld() and CoordFromWorldToPixel() functions to convert pixel to world coordinates and vise-versa. Note: In order to use these two functions, you must add the System.Drawing.dll assembly to your project:


void Test()
{
   Editor ed=Tools.Editor;
   Point3d pt1=
       ed.GetPoint("
Please select a point:").Value;
   //You must add the System.Drawing.dll 
   //in the reference of your project.
   System.Drawing.Point pix1;
   Tools.CoordFromWorldToPixel(0,
                  ref pt1,out pix1);
   ed.WriteMessage("
pixel coordinate is" + 
                       pix1.ToString() + 
                       ",world coordinate is" + 
                       pt1.ToString());

   System.Drawing.Point pix2=
       new System.Drawing.Point(100,100);
   Point3d pt2;
   Tools.CoordFromPixelToWorld(0,pix2,out pt2);
   ed.WriteMessage("
pixel coordinate is"+
                       pix2.ToString()+
                       ",world coordinate is"+
                       pt2.ToString());
}

GetBoundingBox()

In the .NET API, the GeomExtents property of an entity can get the corner points of a box that encloses the 3D extents of the entity. But for DBText and MText, the GeomExtents property always returns the point (0,0,0) for the min-point of the box. So, DOTNETARX provides the GetBoundingBox() function to let you get the correct corner points of an entity including the DBText and the MText objects. The return value of GetBoundingBox() is a Point3d array, [0] is the minimum point of the object's bounding box, [1] is the maximum point of the object's bounding box. The following example shows you how to use GetBoundingBox():


void Test()
{
   Editor ed=Tools.Editor;
   ObjectId id=ed.GetEntity("Please select " + 
              "an entity on the screen:
").ObjectId;
   //Gets the ObjectId of a selected entity.
   
   //Gets the the two points of a box 
   //enclosing the selected entity.
   Point3d[] pts=Tools.GetBoundingBox(id);
   //Creates a line to see the output.
   Lines line=new Lines(pts[0],pts[1]);
   Tools.AddEntity(line);
}

Sendcommand and Regen

Sendcommand() function sends a command string to the current document for processing. There is no Regen function in .NET API, so I have added the Regen() function in DOTNETARX. The following example sends a command for evaluation to the AutoCAD command line of a particular drawing. Create a Circle in the active drawing and zoom to display the entire circle:


void Test()
{
    //You don't need the character "
" 
    //for the Return action.
    Tools.SendCommand("_Circle","2,2,0","4");
    Tools.SendCommand("_zoom","a");
    //Refresh view
    Tools.Regen(Tools.RegenType.AllViewPorts);
}

License

This article has no explicit license attached to it but may contain usage terms in the article text or the download files themselves. If in doubt please contact the author via the discussion board below.

Samples for DOTNETARX (a tool for AutoCAD .NET programming)

Samples for DOTNETARX (a tool for AutoCAD .NET programming) Posted on 21-03-2014  In this article, I will give you some samples to show you how to use DOTNETARX. DOTNETARX is a tool for developing ObjectARX programs with .NET languages more easily and it provides some functions to fix the bugs in the ObjectARX managed wrapper class. You can learn more about DOTNETARX from the article: Using DOTNETARX To Develop Your .NET ObjectARX Applications. To run the example given in this article, you will have to create a new project and add the DOTNETARX 2.0 assembly, then in your source file add "using DOTNETARX;" to import the DOTNETARX namespace. For a detailed description of the functions given in this article, you can read the help document for DOTNETARX. 5/10 940

Comment:

To comment you must be logged in members.

Files with category

  • Ground Modelling information using AutoCAD

    View: 263    Download: 1   Comment: 0   Author: none  

    Ground Modelling information using AutoCAD

    Category: Autodesk AutoCAD
    Fields: Other

    2.25/2 review
    This tutorial describes how to create a 3D surface model from contour information using AutoCAD and Key TERRA-FIRMA. The requirement to visualise terrain in 3D, whether existing or proposed is very common in the environmental design professions.

  • 3D Tree Exercise in AutoCAD

    View: 312    Download: 1   Comment: 0   Author: none  

    3D Tree Exercise in AutoCAD

    Category: Autodesk AutoCAD
    Fields: Other

    2.25/2 review
    It is quite difficult to construct convincing looking 3D trees in AutoCAD, however, with a few simple 3D commands at your disposal you should be able to create something which is identifiable as a tree and perhaps hint at a species.

  • Create Basic 3D and Surface Modelling

    View: 296    Download: 1   Comment: 0   Author: none  

    Create Basic 3D and Surface Modelling

    Category: Autodesk AutoCAD
    Fields: Other

    2.25/2 review
    Although AutoCAD has a number of commands for creating special 3D objects, a lot can be achieved by changing the properties of basic 2D objects like polylines. Most 2D objects can be given a thickness using the thickness option in the Properties...

  • Document Model AutoCAD Meshes to Bryce

    View: 303    Download: 0   Comment: 0   Author: none  

    Document Model AutoCAD Meshes to Bryce

    Category: Autodesk AutoCAD
    Fields: Other

    1.5/3 review
    Although you can create very realistic terrain objects in Bryce, it is often difficult to get them to look just like a real place. However, you can use Key Terra-Firma with AutoCAD to create an accurate terrain model from contour or other height...

  • Using AutoCAD to Bryce

    View: 363    Download: 1   Comment: 0   Author: none  

    Using AutoCAD to Bryce

    Category: Autodesk AutoCAD
    Fields: Other

    1.3333333333333/3 review
    This tutorial explains how to take a model built in AutoCAD into Bryce, how to assign materials to the various components of your model,how to use image textures, how to create a simple setting and how to render the resulting scene. Although the key...

  • DXF Import .NET: Read and View AutoCAD Format Files

    View: 2431    Download: 5   Comment: 0   Author: none  

    DXF Import .NET: Read and View AutoCAD Format Files

    Category: Autodesk AutoCAD
    Fields: none

    0/5 review

  • Writing AutoCad DXF files

    View: 2034    Download: 2   Comment: 0   Author: none  

    Writing AutoCad DXF files

    Category: Autodesk AutoCAD
    Fields: Art - Photography

    0/3 review
    This article demonstrate how to write an ASCII DXF files. A DXF file is a file composed of sections and associated values. They are read by AutoCad and then converted to a drawing.

  • Catalogo ETABS v9.6 Documentation

    View: 908    Download: 1   Comment: 0   Author: none  

    Catalogo ETABS v9.6 Documentation

    Category: Autodesk AutoCAD
    Fields: Interior Design - Building

    0/2 review
    For nearly 30 years, ETABS has been recognized as the industry standard for Building Analysis and Design Software. Today, continuing in the same tradition, ETABS has evolved into a completely Integrated Building Analysis and Design Environment. The...

 
Newsletter Email

File suggestion for you

File top downloads

logo codetitle
Codetitle.com - library source code to share, download the file to the community
Copyright © 2015. All rights reserved. codetitle.com Develope by Vinagon .Ltd